Description

I'm losing reports (still? again? | don't even know anymore). I'm

running r22544, with the modification to RExpression.java that |

e-mailed you about. | opened the tpc09 KAR (r430), and tried to

remove the <> signs (3 actors in the structure/analysis composite

actor). | deleted the <> signs, then changed the display name to put
them back. | then saved the KAR, and lost the report. The first

time, | had tried exporting a run archive (forgot about the <>

problem), then made the <> name changes and tried saving them. | then
restarted Kepler, made the same <> name changes, and then tried saving
them and lost the report a second time. | don't have time today to

try it one more time, and | wouldn't be particularly surprised if it

worked the third or fourth time. However, the console log isn't

helpful. I've attached the log and the bogus KAR. You can check out
the starting KAR, which has the report, from svn.

History

#1 - 01/21/2010 06:21 PM - Oliver Soong

I lost another report. | started Kepler, loaded a KAR (that | had just been editing before restarting Kepler), added and connected 2 ports inside a
composite actor, and tried to save. The console debugging output is below. The first two lines indicate when the KAR was first loaded. The 2
DEBUG and 1 WARN lines mark when | attempted to save. The subsequent INFO statements seem normal and the ERROR statements are normal
for this workflow. | have attached the resulting KAR file.

Although this instance of Kepler has a UUID-based AuthNamespace, | don't think that's the problem, as I've been losing reports since before then and
have successfully saved reports with this AuthNamespace.

[run] Adding dummy listener...

[run] Added.

[run] DEBUG (org.kepler.kar.handlers.ReportLayoutKAREntryHandler:save:169) save([urn:lsid:uuid:c05e28ec-
850c-4b13-a31e-£f9d708£d0c02:61:79], urn:lsid:uuid:c05e28ec-850c-4b13-a31e-£9d708£fd0c02:87:1)

[run] DEBUG (org.kepler.kar.handlers.ReportLayoutKAREntryHandler:saveReportLayout:255) saveReportLayout (
urn:lsid:uuid:c05e28ec-850c-4b13-a31e-£9d708£d0c02:61:79)

[run] WARN (org.kepler.kar.handlers.ReportLayoutKAREntryHandler:saveReportLayout:293) reportLayout is n
ull or blank, not saving an entry to KAR

[run] done writing KAR file to C:\Documents and Settings\soong\Desktop\tpcO09-plant-dynamics-woody.kar

[run] INFO (org.kepler.objectmanager.repository.RepositoryManager:&lt;inité&gt;:121) adding repos localR

epository

[run] INFO (org.kepler.objectmanager.repository.RepositoryManager:&lt;init&gt;:121) adding repos kepler
Repository

[run] INFO (org.kepler.objectmanager.repository.RepositoryManager:&lt;inité&gt; :121) adding repos kepler
DevRepository

[run] INFO (org.kepler.objectmanager.repository.RepositoryManager:&lt;inité&gt;:121) adding repos indusR
epository

[run] ERROR (org.ecoinformatics.seek.dataquery.DBTablesGenerator:generateDBTextTable:497) The error in g
enerateDBTable is bad TEXT table source file - line number: 1 java.lang.NumberFormatException: For input strin

g: "25.00" in statement [SET TABLE T1941964836 SOURCE "urn.lsid.localdata.e305afe9.0.0;fs=,"]

[run] ERROR (org.ecoinformatics.seek.dataquery.DBTablesGenerator:generateDBTextTable:497) The error in g
enerateDBTable is bad TEXT table source file - line number: 1 java.lang.NumberFormatException: For input strin
g: "21 Combretum / Acacia nigrescens Rugged Veld" in statement [SET TABLE T1940172571 SOURCE "urn.lsid.lo
caldata.5c61651b.0.0; £s=#x09; ignore_first=true"]

[run] ERROR (org.ecoinformatics.seek.dataquery.DBTablesGenerator:generateDBTextTable:497) The error in g
enerateDBTable is bad TEXT table source file - line number: 155 java.lang.NumberFormatException: For input str
ing: ">" in statement [SET TABLE T1940175454 SOURCE "urn.lsid.localdata.9464d179.0.0;fs=,"]

[run] Adding dummy listener...
[run] Added.

#2 - 01/27/2010 11:46 AM - Oliver Soong
I'm finally able to reproduce the bug. It requires a KAR file with a report that has a local LSID (i.e., the workflow LSID's namespace is the same as
your Kepler namespace) but also has a derivedFrom entry.

From a fresh Kepler, open the workflow and make a change. Saving the KAR should lose the report. Close and re-open the workflow and make the
same change. Saving the KAR should now work.

The bug has two parts. When derivedFrom exists and a change is made to the workflow, WorkflowManager.changeExecuted swaps the valid report
in the workflow with an invalid blank report generated for the first entry in the derivedFrom list. Secondly, changeExecuted is not being called for all
changes. The first time the KAR is opened, it seems to be called and loses the report. The second time the KAR is opened, it is not called and the
report remains linked.

#3 - 01/27/2010 12:32 PM - ben leinfelder
I'm not seeing it called for any workflow that i open via a KAR.
It is called when | open a MOML xml file.

Something is not quite right with the NamedObj.addChangeListener(listener) calls...in that they never seem to hear or be broadcast to.

#4 - 01/27/2010 03:24 PM - Oliver Soong

Technically, | think the bug is fixed as of r22615. However, the fix only addresses the swapping reports half of the problem. Issues with
changeExecuted only being called the first time exist. | think this is caused by problems in ObjectManager.java having to do with addNamedObj,
_namedObjs, Vector.contains and Object.equals.

#5 - 01/27/2010 07:49 PM - ben leinfelder

i'm testing a Map-based ObjectManager implementation so that we don't end up with different namedObjs with the same LSID in the manager at the
same time.

It looks promising, but I'm still seeing a lack of changeExecuted calls after | save a workflow as a kar (and it is opened/reopened during the same
Kepler session).

Also: | can loose a report this way since the LSID changes aren't always being heard. The ReportLayoutKAREntry handler does a decent job going
back 1 LSID in the derivedFrom list to get the layout, but if the LSID is changed more than once, then you are out of luck.

The best solution will be to figure out why the changeListener is not being alerted.

#6 - 01/27/2010 09:41 PM - ben leinfelder

when | reopen the saved KAR | see that the model (TypedCompositeActor) NamedObj that issues the updateRevision() is actually different than the
NamedObj that | added a listener to. So it's clear why the changeExecuted() call is never being caught...but does not explain the discrepancy
between the object manager's model and the frame's model.

#7 - 01/28/2010 10:19 AM - ben leinfelder

needed to ensure we were listening to all revisions of the named object.
reopen if the problem persists

#8 - 03/27/2013 02:27 PM - Redmine Admin
Original Bugzilla ID was 4682

Files
tpc09-plant-dynamics-woody.kar 57.6 KB 01/21/2010 ben leinfelder
tpc09-plant-dynamics-woody.kar 59.5 KB 01/22/2010 Oliver Soong
